<template>

<div class="card px-2" style="font-size: 18px;">
    <div class="mt-3" v-if="show == 'mostrar'">
        <div class="mt-2 alert alert-primary" role="alert">
            <strong>No tiene Clientes registrados</strong> 
        </div>
    </div>
    <div class="mt-3" v-if="showMessage == 'mostrar'">
        <div v-bind:class="classM" role="alert">
            <strong> {{message.data}} satisfactoriamente.</strong> 
        </div>
    </div>
    <div class="card-header my-2">
        Clientes de Geor
        <a class="btn btn-primary btn-icon-split float-right text-white" data-toggle="modal" data-target="#nuevo-cliente">
            <span class="icon text-white-50">
              <i class="fas fa-plus"></i>
            </span>
            <span class="text">Nuevo Cliente</span>
        </a>

        <div class="modal fade bd-example-modal-lg" id="nuevo-cliente" tabindex="-1" role="dialog"
             aria-l
             abelledby="myLargeModalLabel" aria-hidden="true">
          <div class="modal-dialog modal-lg">
            <form method="POST" v-on:submit.prevent="createCliente">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title mx-2" id="exampleModalLabel"><strong>Agregar Nuevo Cliente</strong> </h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    
                        <div class="form-group row">
                            <div class="col-6">
                                <label for="nuevo-cliente-nombre" >Nombre:</label>
                                <input type="text" class="form-control" id="nuevo-cliente-nombre" v-model="newClient.newNombre"> 
                            </div>
                            <div class="col-6">
                                <label for="nuevo-cliente-apellido">Apellido:</label>
                                <input type="text" class="form-control" id="nuevo-cliente-apellido" v-model="newClient.newApellido">
                            </div>   
                        </div>
                        <div class="form-group row">
                            <div class="col-6">
                                <label for="nuevo-cliente-dni">Dni:</label>
                                <input type="text" class="form-control" id="nuevo-cliente-dni" v-model="newClient.newDni"> 
                            </div>
                            <div class="col-6">
                                <label for="nuevo-cliente-fecha">Fecha de Nacimineto:</label>
                                <input type="date" class="form-control" id="nuevo-cliente-fecha" v-model="newClient.newFechaNacimineto">   
                            </div>
                        </div>
                        <div class="form-group row">
                            <div class="col-6">
                                <label for="nuevo-cliente-email">Email:</label>
                                <input type="text" class="form-control" id="nuevo-cliente-email" v-model="newClient.newEmail"> 
                            </div>
                            <div class="col-6">
                                <label for="nuevo-cliente-telefono">Telefóno:</label>
                                <input type="text" class="form-control" id="nuevo-cliente-telefono" v-model="newClient.newTelefono">   
                            </div>
                        </div>
                        <div class="from-group">
                            <select class="custom-select" v-model="newClient.newConcesionario">
                                <option disabled selected>Concesionario</option>

                                <option v-for="concesionario in concesionarios" v-bind:value="concesionario.id">{{concesionario.concesionario }}</option>
                            </select>
                        </div>
                    

                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
                    <button type="submit" class="btn btn-primary">Guardar</button>
                </div>
            </div>
            </form>
          </div>
        </div>

    </div>
    <table class="table table-striped" id="myTable" style="font-size: 14px;">
      <thead class="bg-primary text-white">
        <tr>
        
          <th scope="col">#</th>
          <th scope="col">Nombre</th>
          <th scope="col">Apellido</th>
          <th scope="col">Dni</th>
          <th scope="col">Fecha de Nacimineto</th>
          <th scope="col">email</th>
          <th scope="col">telefono</th>
          <th scope="col">Concesionarios</th>
          <th scope="col">Operación</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for= "client in clients">

          <th scope="row">{{client.id}}</th>
          <td>{{client.name}}</td>
          <td>{{client.apellido}}</td>
          <td>{{client.dni}}</td>
          <td>{{client.fecha_nacimiento}}</td>
          <td>{{client.email}}</td>
          <td>{{client.telefono}}</td>
          <td>{{client.concesionario}}</td>
          <td>
            <button type="button" class="btn btn-primary btn-sm" v-bind:id="'cliente-'+client.id" v-bind:value="client.id" v-on:click.prevent="editCliente(client)"><i class="fas fa-pen"></i></button>
            
            <button type="button" class="btn btn-danger btn-sm"  v-bind:value="client.id" data-toggle="modal" v-bind:data-target="'#eliminar-'+client.id"><i class="fas fa-trash"></i></button>
        </td>
        </tr>
      </tbody>
    </table>

    <div v-for="client in clients">
         <div class="modal fade bd-example-modal-lg" v-bind:id="'info-'+client.id" tabindex="-1" role="dialog"
             aria-labelledby="myLargeModalLabel" aria-hidden="true">
          <div class="modal-dialog modal-lg">
            <form method="POST" v-on:submit.prevent="updateCliente(client)">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title mx-2" id="exampleModalLabel"><strong>Editar Cliente</strong></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    
                        <div class="form-group row">
                            <div class="col-6">
                                <label v-bind:for="'nombre-'+client.id">Nombre:</label>
                                <input type="text" class="form-control"  v-model="newClient.newNombre" v-bind:id="'nombre-'+client.id" required> 
                            </div>
                            <div class="col-6">
                                <label v-bind:for="'apellido-'+client.id">Apellido:</label>
                                <input type="text" class="form-control" v-model="newClient.newApellido" v-bind:id="'apellido-'+client.id" required>
                            </div>   
                        </div>
                        <div class="form-group row">
                            <div class="col-6">
                                <label v-bind:for="'dni-'+client.id">Dni:</label>
                                <input type="text" class="form-control" v-model="newClient.newDni" v-bind:id="'dni-'+client.id" required> 
                            </div>
                            <div class="col-6">
                                <label v-bind:for="'fecha-'+client.id">Fecha de Nacimineto:</label>
                                <input v-model="newClient.newFechaNacimineto" class="form-control" type="date" v-bind:id="'fecha-'+client.id" required>   
                            </div>
                        </div>
                        <div class="form-group row">
                            <div class="col-6">
                                <label v-bind:for="'email-'+client.id">Email:</label>
                                <input v-model="newClient.newEmail" type="text" class="form-control"  v-bind:id="'email-'+client.id" required> 
                            </div>
                            <div class="col-6">
                                <label v-bind:for="'telefono-'+client.id">Telefóno:</label>
                                <input type="text" v-model="newClient.newTelefono" class="form-control" v-bind:id="'telefono-'+client.id"  required>   
                            </div>
                        </div>
                        <div class="from-group">
                            <select class="custom-select" v-model="newClient.newConcesionario">
                                <option selected v-bind:value="client.concesionarios_id">{{client.concesionario}}</option>
                                <option v-for="concesionario in concesionarios" v-bind:value="concesionario.id">{{concesionario.concesionario }}</option>
                            </select>
                        </div>
                    
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
                    <button type="submit" class="btn btn-primary">Actualizar</button>
                </div>
            </div>
            </form>
          </div>
        </div>


        <div class="modal fade bd-example-modal-lg" v-bind:id="'eliminar-'+client.id" tabindex="-1" role="dialog"
             aria-labelledby="myLargeModalLabel" aria-hidden="true">
          <div class="modal-dialog modal-lg">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title mx-2" id="exampleModalLabel"><strong>Eliminar Cliente</strong></h5>
                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <p>¿Estas seguro que deseas eliminar al clientes {{ client.name }}?</p>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-danger" data-dismiss="modal">Cancelar</button>
                    <button type="button" class="btn btn-primary" v-on:click="deleteCliente(client)">Eliminar</button>
                </div>
            </div>
          </div>
        </div>


    </div>

</div>
    
</template>
<script>
    import datables from 'datatables'; 

    export default {
        mounted(){ 
            this.getClientes();
        },
        data(){
            return{
                showMessage:'',
                show:'',
                concesionarios: [],
                clients:[],
                message:'',
                classM:'mt-2 alert alert-success',
                newClient:{
                    newNombre:'',
                    newApellido:'',
                    newDni:'',
                    newFechaNacimineto:'',
                    newEmail:'',
                    newTelefono:'',
                    newConcesionario:'Concesionario',  
                },
            }
        },
        methods:{
            tableClients(){
                $(document).ready(function(){
                    $('#myTable').DataTable({
                        retrieve: true,
                        language: {      
                            "sProcessing":     "Procesando...",
                            "sLengthMenu":     "Mostrar _MENU_ registros",
                            "sZeroRecords":    "No se encontraron resultados",
                            "sEmptyTable":     "Ningún dato disponible en esta tabla =(",
                            "sInfo":           "Mostrando registros del _START_ al _END_ de un total de _TOTAL_ registros",
                            "sInfoEmpty":      "Mostrando registros del 0 al 0 de un total de 0 registros",
                            "sInfoFiltered":   "(filtrado de un total de _MAX_ registros)",
                            "sInfoPostFix":    "",
                            "sSearch":         "Buscar:",
                            "sUrl":            "",
                            "sInfoThousands":  ",",
                            "sLoadingRecords": "Cargando...",
                            "oPaginate": {
                                "sFirst":    "Primero",
                                "sLast":     "Último",
                                "sNext":     "Siguiente",
                                "sPrevious": "Anterior",
                            },
                            "oAria": {
                                "sSortAscending":  ": Activar para ordenar la columna de manera ascendente",
                                "sSortDescending": ": Activar para ordenar la columna de manera descendente",
                            },
                            "buttons": {
                                "copy": "Copiar",
                                "colvis": "Visibilidad",
                            }
                            
                        },
                    });
                });
            },
            getClientes(){
                var urlGetClientes ="getclients";
                axios.get(urlGetClientes).then(response=>{
                    if(response.data.length == 0 ){
                        this.show = 'mostrar';
                    }else{
                        this.show = 'ocultar';
                        this.clients = response.data;
                        console.log(this.clients);
                    }
                    this.getConcesionarios();
                    this.tableClients();
                    
                });
            },
            getConcesionarios(){
                var urlGetConcesionarios = "getconcesionarios";
                axios.get(urlGetConcesionarios).then(response=>{
                    this.concesionarios = response.data;
                });
            },
            deleteCliente(client){
                var urlDeleteCliente = "clientes/"+client.id;
                axios.delete(urlDeleteCliente).then(response=>{
                    this.message=response.data;
                    this.showMessage = 'mostrar';
                    $('#eliminar-'+client.id).modal('hide');
                    this.getClientes();
                     // window.location.href = 'clientes';                          
                })
            },
            createCliente(){
                var urlCreateCliente = "clientes";
                axios.post(urlCreateCliente, this.newClient).then(response=>{
                    this.message=response.data;
                    this.showMessage = 'mostrar';
                    this.newClient.newNombre='';
                    this.newClient.newApellido='';
                    this.newClient.newDni='';
                    this.newClient.newFechaNacimineto='';
                    this.newClient.newEmail='';
                    this.newClient.newTelefono='';
                    this.newClient.newConcesionario ='Concesionarios';
                    $('#nuevo-cliente').modal('hide');
                    this.getClientes();
                }).catch(error =>{
                    this.classM ='alert-danger';
                    this.showMessage = 'error';
                    this.message = 'información invalida';
                    console.log(error.response);
                })
            },
            editCliente(client){
                
                this.newClient.newNombre= client.name;
                this.newClient.newApellido=client.apellido;
                this.newClient.newDni=client.dni;
                this.newClient.newFechaNacimineto=client.fecha_nacimiento;
                this.newClient.newEmail= client.email,
                this.newClient.newTelefono=client.telefono;
                this.newClient.newConcesionario=client.concesionarios_id;
                $('#info-'+client.id).modal('show');           
            },
            updateCliente(client){
                 console.log(this.newClient);
                var urlUpdateCliente = 'clientes/'+client.id;
                axios.put(urlUpdateCliente, this.newClient).then(response=>{
                    this.getClientes();
                    this.newClient = {
                        newNombre:'',
                        newApellido:'',
                        newDni:'',
                        newFechaNacimineto:'',
                        newEmail:'',
                        newTelefono:'',
                        newConcesionario:'Concesionario',  
                    };
                    this.message = response.data;
                    this.showMessage = 'mostrar';
                    $('#info-'+client.id).modal('hide');

                }).catch(error =>{
                    this.classM ='alert-danger';
                    this.showMessage = 'error';
                    this.message = 'información invalida';
                    console.log(error.response);
                });
            }

        }


    }
</script>